<script lang="ts">
  import { Label, Popover, Table, Toast, ToastBody, ToastHeader } from '@sveltestrap/sveltestrap';
  import { keycloak } from '@stores';
  import { Gql } from '@db';

  import ConfigureModal from './components/ConfigureModal.svelte';
  import type { Challenge, ChallengeReturn } from '@models/Challenges';
  import { ChallengesQuery } from '@models/Challenges';
  import type { NullableEventRole } from '@auth/models';
  import { onMount } from 'svelte';
  import type { Color } from 'sveltestrap/src/shared';
  import { EventRole } from '@auth/models';
  import Fa from 'svelte-fa';
  import { faCheck, faCircleXmark, faFlag, faPencil } from '@fortawesome/free-solid-svg-icons';
  import Env from '@env';

  let challenges: Challenge[] = [];
  let totalPoints: number = 0;
  let configureModal: ConfigureModal;
  let queryRole: NullableEventRole;
  let toasts: Object[] = [];

  $: queryRole = $keycloak.getFirstRole([EventRole.CTFAdmin]);
  $: totalPoints = challenges.reduce(
    (total, allChall) => (total += allChall.active.reduce((activeTotal, active) => (activeTotal += active.points), 0)),
    0,
  );

  const ChallengeSink = {
    complete: () => console.warn('Challenge Sink Completed'),
    error: (err: unknown) => console.error(err),
    next: (value: { data: ChallengeReturn }) => {
      challenges = value.data.challenges_challenges;
    },
  };

  onMount(() => {
    Gql.subscribe(`subscription ${ChallengesQuery(Env.EventID)}`, ChallengeSink, { role: queryRole });
  });

  const setUpdateModalAlert = (message: string, color: Color) => {};

  function handleSave(challenge: Challenge, message: string, color: Color) {
    // Add a toast after saving changes to a challenge, whether it was successful or not
    // Make sure that there are never more than 5 toasts.
    while (toasts.length > 5) {
      toasts.shift();
    }

    toasts = [...toasts, { title: challenge.name, message, color }];
  }
</script>

<div class="d-flex justify-content-center align-content-center m-3">
  <button
    type="button"
    on:click={() => configureModal.show()}
    class="btn btn-secondary btn-add-challenge"
    data-toggle="modal"
  >
    <Fa icon={faFlag} /> Add New Challenge
  </button>
  <Label class="m-3 align-self-center">Total Challenge Points (across all active events): {totalPoints}</Label>
</div>

<div class="container">
  <ConfigureModal
    onError={(challenge, msg, color) => handleSave(challenge, msg, color)}
    onSuccess={async (challenge, msg) => handleSave(challenge, msg, 'success')}
    bind:queryRole
    bind:this={configureModal}
  />
</div>

<div class="toastContainer">
  {#each toasts as toast}
    <Toast autohide>
      <ToastHeader icon={toast.color}>{toast.title}</ToastHeader>
      <ToastBody>{toast.message}</ToastBody>
    </Toast>
  {/each}
</div>

<div>
  {#if challenges?.length}
    <Table>
      <thead>
        <tr class="text-white">
          <th>Name</th>
          <th>Category</th>
          <th>Designer</th>
          <th>Description</th>
          <th class="text-truncate">Event Name</th>
          <th>Points</th>
          <th>Release Time</th>
          <th>Released</th>
          <th>Controls</th>
        </tr>
      </thead>
      <tbody>
        {#each challenges as challenge}
          {#each challenge.active.length > 0 ? challenge.active : [null] as activeChallenge}
            <tr class="text-white">
              <td>{challenge.name}</td>
              <td>{challenge.category}</td>
              <td>{challenge.designer}</td>
              <td class="text-truncate challenge-description">{challenge.description}</td>
              {#if activeChallenge}
                <td>{activeChallenge.event.name}</td>
                <td>{activeChallenge.points}</td>
                <td>{activeChallenge.release_time || 'Not Set'}</td>
                <td>
                  {#if activeChallenge.released}
                    <Fa icon={faCheck} class="text-success" />
                  {:else}
                    <Fa icon={faCircleXmark} class="text-danger" />
                  {/if}
                </td>
              {:else}
                <td /> <td /> <td /> <td />
              {/if}

              <th>
                <div class="btn-group btn-group-sm">
                  <!-- TODO right align buttons -->
                  {#if activeChallenge}
                    <button
                      id={`pop-${challenge.id}_${activeChallenge.event.id}`}
                      type="button"
                      class="btn btn-secondary flag"
                      title=""
                    >
                      <Fa icon={faFlag} />
                    </button>
                    <Popover
                      class="text-white"
                      target={`pop-${challenge.id}_${activeChallenge.event.id}`}
                      placement="bottom"
                      animation
                    >
                      {#each activeChallenge?.flags.length > 0 ? activeChallenge.flags : [{ flag: 'NO FLAGS DEFINED' }] as flag}
                        <p>{flag.flag}</p>
                      {/each}
                    </Popover>
                  {/if}
                  <button
                    type="button"
                    on:click={() => configureModal.show(challenge)}
                    class="btn btn-warning btn-edit"
                  >
                    <Fa icon={faPencil} />
                  </button>
                </div>
              </th>
            </tr>
          {/each}
        {/each}
      </tbody>
    </Table>
  {/if}
</div>

<style>
  .challenge-description {
    max-width: 200px;
    /* number of lines to show */
    -webkit-line-clamp: 3;
    line-clamp: 3;
  }

  .filelist tbody th:last-child {
    padding: 0 4px;
    vertical-align: middle;
  }

  .fileName {
    display: block;
    width: 100px;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
  }
</style>
